﻿using System;
using System.Collections;
using System.ComponentModel;
using System.Data;
using System.Web;
using System.Web.Services;
using System.Web.Services.Protocols;
using System.Collections.Generic;
using System.IO;

namespace Understanding_Linq_1
{
    /// <summary>
    /// Summary description for Service2
    /// </summary>
    [WebService(Namespace = "http://tempuri.org/")]
    [WebServiceBinding(ConformsTo = WsiProfiles.BasicProfile1_1)]
    [ToolboxItem(false)]

    public class WithFilter : System.Web.Services.WebService
    {
        [WebMethod]
        public Employee[] GetEmployees()
        {
            List<Employee> data = new List<Employee>();

            #region ...load data from file...
            using (StreamReader file = File.OpenText(base.Context.Request.MapPath("App_Data/Employees.csv")))
            {
                //skip header
                if (!file.EndOfStream) file.ReadLine();
                //read data
                while (!file.EndOfStream)
                {
                    string line = file.ReadLine();
                    line = line.Trim();

                    //convert to object
                    if (line.Length > 0)
                    {
                        string[] parts = line.Split(';');
                        data.Add(new Employee
                        {
                            Name = parts[0],
                            DateOfBirth = DateTime.Parse(parts[1]),
                            Sex = parts[2],
                            State = parts[3]
                        });
                    }
                }
            }
            #endregion

            //apply filter
            List<Employee> filtered = new List<Employee>();
            foreach (Employee employee in data)
            {
                if (employee.State == "R") filtered.Add(employee);
            }

            return filtered.ToArray();
        }
    }
}
