﻿using System;
using System.Collections.Generic;

namespace Understanding_Linq_2
{
    public class Filter<TData> : IEnumerable<TData> where TData : new()
    {
        public Filter(CsvFileReader<TData> source, Func<TData, bool> filter)
        {
            m_filter = filter;
            m_source = source;
        }

        CsvFileReader<TData> m_source;
        Func<TData, bool> m_filter;

        #region IEnumerable<TData> Members

        public IEnumerator<TData> GetEnumerator()
        {
            foreach (TData current in m_source)
            {
                if (m_filter(current)) yield return current;
            }
        }

        #endregion

        #region IEnumerable Members

        System.Collections.IEnumerator System.Collections.IEnumerable.GetEnumerator()
        {
            return GetEnumerator();
        }

        #endregion

        public Projector<TData, TTarget> Select<TTarget>(Func<TData, TTarget> projection)
        {
            return new Projector<TData, TTarget>(this, projection);
        }
    }
}
